package devoir1;

import static org.junit.Assert.assertEquals;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;


/**
 * Classe de test.
 * @author Serge Rosmorduc (serge.rosmorduc@qenherkhopeshef.org).
 */

public class TestsPourVousAider   {
	@Rule
	public TestRule timeout = Timeout.seconds(2);

	private int second(int tab[])  {
		Integer i = Devoir1.secondeValeur(tab);
		return i;
	}

	private void testException(int t[]) {
		second(t);
	}
	

	@Test(expected=RuntimeException.class)
	public void testNull()  {
		testException(null);
	}

	@Test(expected= RuntimeException.class)
	public void testPasMax()  {
		int[] t = {};
		testException(t);
	}

	@Test(expected= RuntimeException.class)
	public void testPasSecond1()  {
		int[] t = { 1 };
		testException(t);
	}

	@Test(expected= RuntimeException.class)
	public void testPasSecond2()  {
		int[] t = { 1, 1, 1, 1, 1, 1 };
		testException(t);
	}

	@Test
	public void testAutres8a()  {
		assertEquals("recherche dans -10,-2, -6,-9, -1", -2, second(new int[] { -10, -2, -6, -9, -1 }));
	}

	@Test
	public void testAutres9a()  {
		assertEquals("recherche dans -2, -6,-9, -1", -2, second(new int[] { -2, -6, -9, -1 }));
	}

	@Test
	public void testAutres10a()  {
		assertEquals("recherche dans -1, -6,-9, -2", -2, second(new int[] { -1, -6, -9, -2 }));
	}

	@Test
	public void testAutres8b()  {
		assertEquals("recherche dans -10,-2, -6,-9, -1", -2, second(new int[] { -10, -2, -6, -9, -1 }));
	}

	@Test
	public void testAutres9b()  {
		assertEquals("recherche dans -2, -6,-9, -1", -2, second(new int[] { -2, -6, -9, -1 }));
	}

	@Test
	public void testAutres10b()  {
		assertEquals("recherche dans -1, -6,-9, -2", -2, second(new int[] { -1, -6, -9, -2 }));
	}

	@Test
	public void testAutres8()  {
		assertEquals("recherche dans -10,-2, -6,-9, -1", -2, second(new int[] { -10, -2, -6, -9, -1 }));
	}

	@Test
	public void testAutres9()  {
		assertEquals("recherche dans -2, -6,-9, -1", -2, second(new int[] { -2, -6, -9, -1 }));
	}

	@Test
	public void testAutres10()  {
		assertEquals("recherche dans -1, -6,-9, -2", -2, second(new int[] { -1, -6, -9, -2 }));
	}

	@Test
	public void testMinValA()  {
		int attendu = Integer.MIN_VALUE;
		int[] param = { 1, Integer.MIN_VALUE };
		assertEquals("recherche dans 1, Integer.MIN_VALUE échoue", attendu, second(param));
	}

}
